/*
 *      Copyright(C) 2001-2004 NAKAYAMA Hiroyoshi
 *
 * 	Licensed under the terms of the GNU GPL License version 2.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "miscio.h"

int ArgCheck(int argc, char *argv[], char *str)
{
  int i;
  for (i = 1; i < argc; i ++)
    if (strstr(argv[i],str)==argv[i] && strlen(str)==strlen(argv[i]))
      return (i);
  return (0);
}

int Arg2i(int argc, char *argv[], char *str, int *r)
{
  int tmp;
  if((tmp = ArgCheck(argc,argv,str)) != 0){
    if (tmp+1 < argc)
      *r = atoi(argv[tmp+1]);
    return (1);
  }
  return (0);
}

int Arg2f(int argc, char *argv[], char *str, double *r)
{
  int tmp;
  if((tmp = ArgCheck(argc,argv,str)) != 0){
    if (tmp+1 < argc)
      *r = atof(argv[tmp+1]);
    return (1);
  }
  return (0);
}

int Arg2c(int argc, char *argv[], char *str, char *r)
{
  int tmp;
  if((tmp = ArgCheck(argc,argv,str)) != 0){
    if (tmp+1 < argc)
      *r = *argv[tmp+1];
    return (1);
  }
  return (0);
}

int Arg2s(int argc, char *argv[], char *str, char **r)
{
  int tmp;
  if((tmp = ArgCheck(argc,argv,str)) != 0){
    if (tmp+1 < argc)
      *r = argv[tmp+1];
    return (1);
  }
  return (0);
}

int ArgFlag(int argc, char *argv[], char *str)
{
  int tmp;
  if((tmp = ArgCheck(argc,argv,str)) != 0)
    return (1);
  return (0);
}

int File2Arg(char *filename, int *fargc, char ***fargv)
{
  FILE *fptr;
  char str[256];
  int  len = 0;

  if ((fptr = fopen(filename,"r")) == NULL)
    return (0);

  (*fargc) = 0;
  *fargv   = (char **)malloc((size_t)(256*sizeof(char *)));

  len = strlen(filename)+1;
  (*fargv)[*fargc] = (char *)malloc((size_t)(len*sizeof(char)));
  strcpy((*fargv)[*fargc],filename);

  while (GetWord(fptr,str)){
    len = strlen(str)+1;
    (*fargc)++;
    (*fargv)[*fargc] = (char *)malloc((size_t)(len*sizeof(char)));
    strcpy((*fargv)[*fargc],str);
  }

  (void)fclose(fptr);
  return(1);
}

void File2ArgFree(int fargc,char **fargv)
{
  int i;
  for (i = 0; i < fargc; i ++)
    free(fargv[i]);
  if (i > 0 && fargv != NULL)
    free(fargv);
}

int ArgGetOption(struct ARGOPTION *argoption, int argc, char *argv[])
{
  int    i = 0;
  int    ri;
  double rf;
  char  *rs;
  char   rc;

  while (argoption[i].type < END) {
    switch(argoption[i].type) {
    case NOARG:
    case FLAG:
      argoption[i].data.flag = ArgFlag(argc, argv, argoption[i].option);
      break;
    case INT:
      if (Arg2i(argc, argv, argoption[i].option, &ri) == 1)
	argoption[i].data.idata = ri;
      break;
    case FLOAT:
      if (Arg2f(argc, argv, argoption[i].option, &rf) == 1)
	argoption[i].data.fdata = rf;
      break;
    case STRINGS:
      if (Arg2s(argc, argv, argoption[i].option, &rs) == 1)
	argoption[i].data.sdata = rs;
      break;
    case CHAR:
      if (Arg2c(argc, argv, argoption[i].option, &rc) == 1)
	argoption[i].data.cdata = rc;
      break;
    }
    i ++;
  }
}

int FArgGetOption(struct ARGOPTION *argoption, char *file)
{
  int   fargc = 0;
  char **fargv;

  if (File2Arg(file, &fargc, &fargv) == 1) {
    ArgGetOption(argoption, fargc, fargv);
    /*    File2ArgFree(fargc,fargv); */
    return(1);
  }
  else
    return(0);
}
