/*
 *	This file is part of tkK7mauto
 *      Copyright(C) 2004 NAKAYAMA Hiroyoshi
 *
 * 	Licensed under the terms of the GNU GPL License version 2.
 */
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <linux/version.h>
#include <math.h>

//#define DEBUG

int prev_user, prev_nice, prev_system, prev_idle;

double cpustat()
{
  static int init_flag = 0;
  static int pstat = -1;
  char buf[1024], dummy[32];
  int len;
  int user, nice, system, idle;
  int nstates, states[4], all, i;
  double userf;


  if (pstat == -1) {
    pstat = open("/proc/stat", O_RDONLY);
    /*    printf("open(%d)\n",pstat);	/*  */
  }

  if(pstat == -1)
    perror("open /proc/stat"), exit(1);
  lseek(pstat, 0, SEEK_SET);
  len = read(pstat, buf, sizeof(buf));

  buf[len] = 0;
  sscanf(buf,"%s %d %d %d %d", dummy, &user, &nice, &system, &idle);

  nstates = 0;
  states[nstates++] = idle - prev_idle;
  states[nstates++] = user - prev_user; 
  states[nstates++] = nice - prev_nice; 
  states[nstates++] = system - prev_system; 
  prev_idle = idle;
  prev_user = user;
  prev_nice = nice;
  prev_system = system;

  all = 0;
  for (i = 0 ; i < 4; i ++)
    all += (double)states[i];

#if 1
  /* $BA4$F$N(B load $B$r4F;k$9$k@_Dj(B */
  userf = (double)(states[1]+states[2]+states[3])/(double)all;
#else
  /* system $B$rH4$+$9@_Dj(B */
  userf = (double)(states[1]+states[3])/(double)all;
#endif

  if (init_flag)
    return(userf);
  else {
    init_flag = 1;
    return(-1);
  }
}

#ifdef DEBUG
int main ()
{
  double f;

  while (1) {
    f = cpustat();
    printf("%f\n",f);
    sleep (1);
  }
}
#endif
